/* Problem URL: https://codeforces.com/edu/course/2/lesson/5/4/practice/contest/280801/problem/C */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    int middle = 500000;

    int size = 1 << (32 - __builtin_clz(1e6 + middle + 1));

    struct node {
        int sum;
        int seg;
        bool suf;
        bool pref;
        bool total;

        node() = default;
    };

    V<node> seg(size * 2);
    V<bool> upd(size * 2);
    vi lazy(size * 2);

    auto merge = [&](node &a, node &b) -> node {
        node ans;
        ans.sum = a.sum + b.sum;

        if (a.total && b.total) {
            ans.total = true;
            ans.pref = true;
            ans.suf = true;
            ans.seg = 1;

            return ans;
        }

        ans.seg = a.seg + b.seg - (a.suf && b.pref);
        ans.pref = a.pref;
        ans.suf = b.suf;
        ans.total = false;

        return ans;
    };

    auto propagate = [&](int i, int l, int r) {
        if (!upd[i]) {
            return;
        }

        upd[i] = false;

        seg[i].sum = lazy[i] * (r - l + 1);
        seg[i].pref = lazy[i];
        seg[i].suf = lazy[i];
        seg[i].total = lazy[i];
        seg[i].seg = lazy[i];

        if (i < size) {
            lazy[i * 2] = lazy[i];
            lazy[i * 2 + 1] = lazy[i];
            upd[i * 2] = true;
            upd[i * 2 + 1] = true;
        }

        return;
    };

    function<void(int, int, int, int, int, int)> update = [&](int i, int l, int r, int tl, int tr, int v) {
        propagate(i, l, r);
        
        if (l > tr || r < tl) {
            return;
        }

        if (l >= tl && r <= tr) {
            lazy[i] = v;
            upd[i] = true;
            propagate(i, l, r);
            return;
        }

        int mid = (l + r) >> 1;

        update(i * 2, l, mid, tl, tr, v);
        update(i * 2 + 1, mid + 1, r, tl, tr, v);
        
        seg[i] = merge(seg[i * 2], seg[i * 2 + 1]);
    };

    auto query = [&]() {
        propagate(1, 0, size - 1);

        return seg[1];
    };

    rep(i, n) {
        char op;
        int x, l;
        cin >> op >> x >> l;
        x += middle;

        op = op == 'B';

        update(1, 0, size - 1, x, x + l - 1, op);

        auto ans = query();
        cout << ans.seg << ' ' << ans.sum << '\n';
    }
}
